/*-
 * Copyright (C)2012 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2012 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: top.c,v 1.1 2013/07/06 06:00:05 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <termios.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <babolo/BLINflag.h>
#include <mercumeter.h>

extern BLIN_flag blin_pamparam_internal;

memeter *
memeter_init(u_int32_t flags) {
    ifBLIN_FLAG = flags;
    memeter *mt = NULL;

    if  (!(mt = calloc(1, sizeof(memeter)))) {
        errno = ENOMEM;
        ifBLIN_QW0("Malloc failed #1");
    } else {
        mt->flags = flags;
    }
    return(mt);
}

void
memeter_fini(memeter *mt) {
    ifBLIN_FLAG = mt ? mt->flags : blin_pamparam_internal;
    u_int32_t i;

    if  (mt) {
        if  (mt->grp) {
            for (i = 0; i < mt->grpn; ++i) {
                free(mt->grp[i]);
            }
            free(mt->grp);
        }
        free(mt->cnt);
        if  (mt->acc) {
            for (i = 0; i < mt->accn; ++i) {
                if  (mt->acc[i]) mt->acc[i]->fini(mt->acc[i]);
            }
            free(mt->acc);
}   }   }
